### Internal structure of scala.meta ASTs

We use macro annotations to generate swaths of boilerplate that make our abstract syntax trees efficient and convenient.
Here's the code that we write in [Trees.scala](/scalameta/trees/src/main/scala/scala/meta/Trees.scala):

```
@ast class If(cond: Term, thenp: Term, elsep: Term) extends Term
```

Here's the code generated by the `@ast` macro annotation:

```
@new _root_.scala.meta.internal.ast.Metadata.astClass() @new _root_.org.scalameta.adt.Metadata.leafClass() abstract trait If extends Term with _root_.scala.Product {
  @new _root_.scala.meta.internal.ast.Metadata.astField() def cond: Term;
  @new _root_.scala.meta.internal.ast.Metadata.astField() def thenp: Term;
  @new _root_.scala.meta.internal.ast.Metadata.astField() def elsep: Term;
  def copy(cond: Term = this.cond, thenp: Term = this.thenp, elsep: Term = this.elsep): If
}
@new _root_.scala.meta.internal.ast.Metadata.astCompanion() @new _root_.org.scalameta.adt.Metadata.leafCompanion() object If extends scala.AnyRef {
  def <init>() = {
    super.<init>();
    ()
  };
  private object sharedClassifier extends _root_.scala.meta.classifiers.Classifier[_root_.scala.meta.Tree, If] {
    def <init>() = {
      super.<init>();
      ()
    };
    def apply(x: _root_.scala.meta.Tree): Boolean = x.isInstanceOf[If]
  };
  implicit def ClassifierClass[T <: _root_.scala.meta.Tree]: _root_.scala.meta.classifiers.Classifier[T, If] = sharedClassifier.asInstanceOf[_root_.scala.meta.classifiers.Classifier[T, If]];
  def apply(cond: Term, thenp: Term, elsep: Term): If = {
    def internal(cond: Term, thenp: Term, elsep: Term): If = {
      _root_.scala.meta.internal.ast.CommonTyperMacros.hierarchyCheck[If];
      _root_.org.scalameta.data.DataTyperMacros.nullCheck(cond);
      _root_.org.scalameta.data.DataTyperMacros.nullCheck(thenp);
      _root_.org.scalameta.data.DataTyperMacros.nullCheck(elsep);
      _root_.org.scalameta.data.DataTyperMacros.emptyCheck(cond);
      _root_.org.scalameta.data.DataTyperMacros.emptyCheck(thenp);
      _root_.org.scalameta.data.DataTyperMacros.emptyCheck(elsep);
      val node = new TermIfImpl(_root_.scala.meta.internal.flags.ZERO, null, null, null, null, null)(_root_.scala.meta.internal.ast.CommonTyperMacros.initParam(cond), _root_.scala.meta.internal.ast.CommonTyperMacros.initParam(thenp), _root_.scala.meta.internal.ast.CommonTyperMacros.initParam(elsep));
      _root_.scala.meta.internal.ast.CommonTyperMacros.storeField(node._cond, cond);
      _root_.scala.meta.internal.ast.CommonTyperMacros.storeField(node._thenp, thenp);
      _root_.scala.meta.internal.ast.CommonTyperMacros.storeField(node._elsep, elsep);
      node
    };
    internal(cond, thenp, elsep)
  };
  @new _root_.scala.inline() final def unapply(x: If): _root_.scala.Option[scala.Tuple3[Term, Term, Term]] = if (x.$eq$eq(null))
    _root_.scala.None
  else
    _root_.scala.Some(scala.Tuple3(x.cond, x.thenp, x.elsep));
  @new _root_.scala.meta.internal.ast.ast() private[meta] class Quasi extends If with _root_.scala.meta.internal.ast.Quasi with Term.Quasi {
    <paramaccessor> private[this] val rank: _root_.scala.Int = _;
    <paramaccessor> private[this] val tree: _root_.scala.Any = _;
    def <init>(rank: _root_.scala.Int, tree: _root_.scala.Any) = {
      super.<init>();
      ()
    };
    def pt: _root_.java.lang.Class[_$50] forSome {
      <synthetic> type _$50
    } = _root_.scala.meta.internal.ast.Helpers.arrayClass(_root_.scala.Predef.classOf[If], this.rank);
    def cond: _root_.scala.Nothing = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position");
    def thenp: _root_.scala.Nothing = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position");
    def elsep: _root_.scala.Nothing = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position");
    def name: _root_.scala.Nothing = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position");
    def value: _root_.scala.Nothing = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position");
    def copy(cond: Term = this.cond, thenp: Term = this.thenp, elsep: Term = this.elsep): If = throw new _root_.scala.UnsupportedOperationException(if (this.rank.$eq$eq(0))
      "unsupported unquoting position"
    else
      "unsupported splicing position")
  };
  @new _root_.scala.SerialVersionUID(1L) final private[If] class TermIfImpl extends If {
    <paramaccessor> private[meta] val privateFlags: _root_.scala.meta.internal.flags.Flags = _;
    @new _root_.scala.transient() <paramaccessor> private[meta] val privatePrototype: If = _;
    <paramaccessor> private[meta] val privateParent: _root_.scala.meta.Tree = _;
    @new _root_.scala.transient() <paramaccessor> private[meta] var privateTokens: _root_.scala.meta.tokens.Tokens = _;
    override <paramaccessor> private[meta] val privateEnv: _root_.scala.meta.internal.semantic.Environment = _;
    override <paramaccessor> private[meta] val privateTyping: _root_.scala.meta.internal.semantic.Typing = _;
    <paramaccessor> var _cond: Term = _;
    <paramaccessor> var _thenp: Term = _;
    <paramaccessor> var _elsep: Term = _;
    def <init>(privateFlags: _root_.scala.meta.internal.flags.Flags, @new _root_.scala.transient() privatePrototype: If, privateParent: _root_.scala.meta.Tree, @new _root_.scala.transient() privateTokens: _root_.scala.meta.tokens.Tokens, privateEnv: _root_.scala.meta.internal.semantic.Environment, privateTyping: _root_.scala.meta.internal.semantic.Typing)(_cond: Term, _thenp: Term, _elsep: Term) = {
      super.<init>();
      ()
    };
    def cond: Term = {
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._cond);
      this._cond
    };
    def thenp: Term = {
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._thenp);
      this._thenp
    };
    def elsep: Term = {
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._elsep);
      this._elsep
    };
    private[meta] def privateCopy(flags: _root_.scala.meta.internal.flags.Flags = privateFlags, prototype: _root_.scala.meta.Tree = this, parent: _root_.scala.meta.Tree = privateParent, tokens: _root_.scala.meta.tokens.Tokens = privateTokens, env: _root_.scala.meta.internal.semantic.Environment = privateEnv, denot: _root_.scala.meta.internal.semantic.Denotation = privateDenot, typing: _root_.scala.meta.internal.semantic.Typing = privateTyping): Tree = new TermIfImpl(flags, prototype.asInstanceOf[If], parent, tokens, env, typing)(_root_.scala.meta.internal.ast.CommonTyperMacros.initField(this._cond), _root_.scala.meta.internal.ast.CommonTyperMacros.initField(this._thenp), _root_.scala.meta.internal.ast.CommonTyperMacros.initField(this._elsep));
    def copy(cond: Term = this.cond, thenp: Term = this.thenp, elsep: Term = this.elsep): If = If.apply(cond, thenp, elsep).withTokens(tokens = new _root_.scala.meta.internal.tokens.TransformedTokens(this));
    def children: Seq[_root_.scala.meta.Tree] = _root_.scala.meta.internal.ast.CommonTyperMacros.children[If, _root_.scala.meta.Tree];
    override def productPrefix: _root_.scala.Predef.String = _root_.scala.meta.internal.ast.CommonTyperMacros.productPrefix[If];
    override def productArity: _root_.scala.Int = 3;
    override def productElement(n: _root_.scala.Int): Any = n match {
      case 0 => this.cond
      case 1 => this.thenp
      case 2 => this.elsep
      case _ => throw new _root_.scala.IndexOutOfBoundsException(n.toString)
    };
    override def productIterator: _root_.scala.Iterator[_root_.scala.Any] = _root_.scala.runtime.ScalaRunTime.typedProductIterator(this);
    protected def writeReplace(): _root_.scala.AnyRef = {
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._cond);
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._thenp);
      _root_.scala.meta.internal.ast.CommonTyperMacros.loadField(this._elsep);
      this
    }
  }
}
```

Here's the same code after typechecking with helper def macros expanded:

```
@meta.internal.ast.Metadata.astClass @org.scalameta.adt.Metadata.leafClass abstract trait If extends AnyRef with scala.meta.Term with Product {
  @meta.internal.ast.Metadata.astField def cond: scala.meta.Term;
  @meta.internal.ast.Metadata.astField def thenp: scala.meta.Term;
  @meta.internal.ast.Metadata.astField def elsep: scala.meta.Term;
  def copy(cond: scala.meta.Term = this.cond, thenp: scala.meta.Term = this.thenp, elsep: scala.meta.Term = this.elsep): scala.meta.Term.If;
  <synthetic> def copy$default$1: scala.meta.Term = this.cond;
  <synthetic> def copy$default$2: scala.meta.Term = this.thenp;
  <synthetic> def copy$default$3: scala.meta.Term = this.elsep
};
@@<?> @@<?> object If extends scala.AnyRef with Serializable {
  def <init>(): scala.meta.Term.If.type = {
    If.super.<init>();
    ()
  };
  private object sharedClassifier extends AnyRef with scala.meta.classifiers.Classifier[scala.meta.Tree,scala.meta.Term.If] {
    def <init>(): scala.meta.Term.If.sharedClassifier.type = {
      sharedClassifier.super.<init>();
      ()
    };
    def apply(x: scala.meta.Tree): Boolean = x.isInstanceOf[scala.meta.Term.If]
  };
  implicit def ClassifierClass[T <: scala.meta.Tree]: scala.meta.classifiers.Classifier[T,scala.meta.Term.If] = If.this.sharedClassifier.asInstanceOf[scala.meta.classifiers.Classifier[T,scala.meta.Term.If]];
  def apply(cond: scala.meta.Term, thenp: scala.meta.Term, elsep: scala.meta.Term): scala.meta.Term.If = {
    def internal(cond: scala.meta.Term, thenp: scala.meta.Term, elsep: scala.meta.Term): scala.meta.Term.If = {
      ((): Unit);
      (({
        val result$macro$188: Boolean = cond.!=(null);
        if (result$macro$188)
          scala.Tuple2.apply[Boolean, collection.immutable.Nil.type](true, scala.collection.immutable.Nil)
        else
          scala.Tuple2.apply[Boolean, List[String]](false, scala.collection.immutable.List.apply[String]("cond is equal to null"))
      } match {
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(true, _) => ()
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(false, (failures$macro$187 @ _)) => org.scalameta.invariants.InvariantFailedException.raise("cond.!=(null)", failures$macro$187, scala.collection.immutable.Map.apply[String, scala.meta.Term](scala.Tuple2.apply[String, scala.meta.Term]("cond", cond)))
      }: Unit): Unit);
      (({
        val result$macro$190: Boolean = thenp.!=(null);
        if (result$macro$190)
          scala.Tuple2.apply[Boolean, collection.immutable.Nil.type](true, scala.collection.immutable.Nil)
        else
          scala.Tuple2.apply[Boolean, List[String]](false, scala.collection.immutable.List.apply[String]("thenp is equal to null"))
      } match {
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(true, _) => ()
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(false, (failures$macro$189 @ _)) => org.scalameta.invariants.InvariantFailedException.raise("thenp.!=(null)", failures$macro$189, scala.collection.immutable.Map.apply[String, scala.meta.Term](scala.Tuple2.apply[String, scala.meta.Term]("thenp", thenp)))
      }: Unit): Unit);
      (({
        val result$macro$192: Boolean = elsep.!=(null);
        if (result$macro$192)
          scala.Tuple2.apply[Boolean, collection.immutable.Nil.type](true, scala.collection.immutable.Nil)
        else
          scala.Tuple2.apply[Boolean, List[String]](false, scala.collection.immutable.List.apply[String]("elsep is equal to null"))
      } match {
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(true, _) => ()
        case (_1: Boolean, _2: List[String])(Boolean, List[String])(false, (failures$macro$191 @ _)) => org.scalameta.invariants.InvariantFailedException.raise("elsep.!=(null)", failures$macro$191, scala.collection.immutable.Map.apply[String, scala.meta.Term](scala.Tuple2.apply[String, scala.meta.Term]("elsep", elsep)))
      }: Unit): Unit);
      ((): Unit);
      ((): Unit);
      ((): Unit);
      val node: scala.meta.Term.If.TermIfImpl = new If.this.TermIfImpl(scala.meta.internal.flags.`package`.ZERO, null, null, null, null, null)((null: scala.meta.Term), (null: scala.meta.Term), (null: scala.meta.Term));
      (node._cond_=({
<artifact> val x$682: scala.meta.Term = cond;
<artifact> val x$683: scala.meta.Term.If.TermIfImpl = node;
<artifact> val x$684: meta.internal.flags.Flags = cond.privateCopy$default$1;
<artifact> val x$685: scala.meta.tokens.Tokens = cond.privateCopy$default$4;
<artifact> val x$686: scala.meta.internal.semantic.Environment = cond.privateCopy$default$5;
<artifact> val x$687: scala.meta.internal.semantic.Denotation = cond.privateCopy$default$6;
<artifact> val x$688: scala.meta.internal.semantic.Typing = cond.privateCopy$default$7;
cond.privateCopy(x$684, x$682, x$683, x$685, x$686, x$687, x$688)
}.asInstanceOf[scala.meta.Term]): Unit);
      (node._thenp_=({
<artifact> val x$689: scala.meta.Term = thenp;
<artifact> val x$690: scala.meta.Term.If.TermIfImpl = node;
<artifact> val x$691: meta.internal.flags.Flags = thenp.privateCopy$default$1;
<artifact> val x$692: scala.meta.tokens.Tokens = thenp.privateCopy$default$4;
<artifact> val x$693: scala.meta.internal.semantic.Environment = thenp.privateCopy$default$5;
<artifact> val x$694: scala.meta.internal.semantic.Denotation = thenp.privateCopy$default$6;
<artifact> val x$695: scala.meta.internal.semantic.Typing = thenp.privateCopy$default$7;
thenp.privateCopy(x$691, x$689, x$690, x$692, x$693, x$694, x$695)
}.asInstanceOf[scala.meta.Term]): Unit);
      (node._elsep_=({
<artifact> val x$696: scala.meta.Term = elsep;
<artifact> val x$697: scala.meta.Term.If.TermIfImpl = node;
<artifact> val x$698: meta.internal.flags.Flags = elsep.privateCopy$default$1;
<artifact> val x$699: scala.meta.tokens.Tokens = elsep.privateCopy$default$4;
<artifact> val x$700: scala.meta.internal.semantic.Environment = elsep.privateCopy$default$5;
<artifact> val x$701: scala.meta.internal.semantic.Denotation = elsep.privateCopy$default$6;
<artifact> val x$702: scala.meta.internal.semantic.Typing = elsep.privateCopy$default$7;
elsep.privateCopy(x$698, x$696, x$697, x$699, x$700, x$701, x$702)
}.asInstanceOf[scala.meta.Term]): Unit);
      node
    };
    internal(cond, thenp, elsep)
  };
  @inline final def unapply(x: scala.meta.Term.If): Option[(scala.meta.Term, scala.meta.Term, scala.meta.Term)] = if (x.==(null))
    scala.None
  else
    scala.Some.apply[(scala.meta.Term, scala.meta.Term, scala.meta.Term)](scala.Tuple3.apply[scala.meta.Term, scala.meta.Term, scala.meta.Term](x.cond, x.thenp, x.elsep));
  @meta.internal.ast.Metadata.astClass @org.scalameta.adt.Metadata.leafClass abstract private[meta] trait Quasi extends AnyRef with scala.meta.Term.If with scala.meta.internal.ast.Quasi with scala.meta.Term.Quasi with Product {
    @meta.internal.ast.Metadata.astField def rank: Int;
    @meta.internal.ast.Metadata.astField def tree: Any
  };
  @@<?> @@<?> private[meta] object Quasi extends scala.AnyRef with Serializable {
    def <init>(): scala.meta.Term.If.Quasi.type = {
      Quasi.super.<init>();
      ()
    };
    private object sharedClassifier extends AnyRef with scala.meta.classifiers.Classifier[scala.meta.Tree,scala.meta.Term.If.Quasi] {
      def <init>(): scala.meta.Term.If.Quasi.sharedClassifier.type = {
        sharedClassifier.super.<init>();
        ()
      };
      def apply(x: scala.meta.Tree): Boolean = x.isInstanceOf[scala.meta.Term.If.Quasi]
    };
    implicit def ClassifierClass[T <: scala.meta.Tree]: scala.meta.classifiers.Classifier[T,scala.meta.Term.If.Quasi] = Quasi.this.sharedClassifier.asInstanceOf[scala.meta.classifiers.Classifier[T,scala.meta.Term.If.Quasi]];
    def apply(rank: Int, tree: Any): scala.meta.Term.If.Quasi = {
      def internal(rank: Int, tree: Any): scala.meta.Term.If.Quasi = {
        ((): Unit);
        ((): Unit);
        ((): Unit);
        ((): Unit);
        ((): Unit);
        val node: scala.meta.Term.If.Quasi.TermIfQuasiImpl = new Quasi.this.TermIfQuasiImpl(scala.meta.internal.flags.`package`.ZERO, null, null, null)((rank: Int), (tree: Any));
        ((): Unit);
        ((): Unit);
        node
      };
      internal(rank, tree)
    };
    @inline final def unapply(x: scala.meta.Term.If.Quasi): Option[(Int, Any)] = if (x.==(null))
      scala.None
    else
      scala.Some.apply[(Int, Any)](scala.Tuple2.apply[Int, Any](x.rank, x.tree));
    @SerialVersionUID(value = 1L) final private[Quasi] class TermIfQuasiImpl extends AnyRef with scala.meta.Term.If.Quasi {
      <paramaccessor> private[this] val privateFlags: meta.internal.flags.Flags = _;
      <stable> <accessor> <paramaccessor> private[meta] def privateFlags: meta.internal.flags.Flags = TermIfQuasiImpl.this.privateFlags;
      @transient <paramaccessor> private[this] val privatePrototype: scala.meta.Term.If.Quasi = _;
      <stable> <accessor> <paramaccessor> private[meta] def privatePrototype: scala.meta.Term.If.Quasi = TermIfQuasiImpl.this.privatePrototype;
      <paramaccessor> private[this] val privateParent: scala.meta.Tree = _;
      <stable> <accessor> <paramaccessor> private[meta] def privateParent: scala.meta.Tree = TermIfQuasiImpl.this.privateParent;
      @transient <paramaccessor> private[this] var privateTokens: scala.meta.tokens.Tokens = _;
      <accessor> <paramaccessor> private[meta] def privateTokens: scala.meta.tokens.Tokens = TermIfQuasiImpl.this.privateTokens;
      <accessor> <paramaccessor> private[meta] def privateTokens_=(x$1: scala.meta.tokens.Tokens): Unit = TermIfQuasiImpl.this.privateTokens = x$1;
      <paramaccessor> private[this] var _rank: Int = _;
      <accessor> <paramaccessor> def _rank: Int = TermIfQuasiImpl.this._rank;
      <accessor> <paramaccessor> def _rank_=(x$1: Int): Unit = TermIfQuasiImpl.this._rank = x$1;
      <paramaccessor> private[this] var _tree: Any = _;
      <accessor> <paramaccessor> def _tree: Any = TermIfQuasiImpl.this._tree;
      <accessor> <paramaccessor> def _tree_=(x$1: Any): Unit = TermIfQuasiImpl.this._tree = x$1;
      def <init>(privateFlags: meta.internal.flags.Flags, privatePrototype: scala.meta.Term.If.Quasi, privateParent: scala.meta.Tree, privateTokens: scala.meta.tokens.Tokens)(_rank: Int, _tree: Any): scala.meta.Term.If.Quasi.TermIfQuasiImpl = {
        TermIfQuasiImpl.super.<init>();
        ()
      };
      def pt: Class[_] = scala.meta.internal.ast.Helpers.arrayClass(classOf[scala.meta.Term$$If], this.rank);
      def cond: Nothing = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      def thenp: Nothing = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      def elsep: Nothing = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      def name: Nothing = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      def value: Nothing = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      def copy(cond: scala.meta.Term = this.cond, thenp: scala.meta.Term = this.thenp, elsep: scala.meta.Term = this.elsep): scala.meta.Term.If = throw new scala.`package`.UnsupportedOperationException(if (this.rank.==(0))
        "unsupported unquoting position"
      else
        "unsupported splicing position");
      override <synthetic> def copy$default$1: scala.meta.Term = this.cond;
      override <synthetic> def copy$default$2: scala.meta.Term = this.thenp;
      override <synthetic> def copy$default$3: scala.meta.Term = this.elsep;
      def rank: Int = {
        ((): Unit);
        this._rank
      };
      def tree: Any = {
        ((): Unit);
        this._tree
      };
      private[meta] def privateCopy(flags: meta.internal.flags.Flags = TermIfQuasiImpl.this.privateFlags, prototype: scala.meta.Tree = this, parent: scala.meta.Tree = TermIfQuasiImpl.this.privateParent, tokens: scala.meta.tokens.Tokens = TermIfQuasiImpl.this.privateTokens, env: scala.meta.internal.semantic.Environment = TermIfQuasiImpl.this.privateEnv, denot: scala.meta.internal.semantic.Denotation = TermIfQuasiImpl.this.privateDenot, typing: scala.meta.internal.semantic.Typing = TermIfQuasiImpl.this.privateTyping): scala.meta.Tree = new Quasi.this.TermIfQuasiImpl(flags, prototype.asInstanceOf[scala.meta.Term.If.Quasi], parent, tokens)((this._rank: Int), (this._tree: Any));
      override <synthetic> def privateCopy$default$1: meta.internal.flags.Flags = TermIfQuasiImpl.this.privateFlags;
      override <synthetic> def privateCopy$default$2: scala.meta.Tree = this;
      override <synthetic> def privateCopy$default$3: scala.meta.Tree = TermIfQuasiImpl.this.privateParent;
      override <synthetic> def privateCopy$default$4: scala.meta.tokens.Tokens = TermIfQuasiImpl.this.privateTokens;
      override <synthetic> def privateCopy$default$5: scala.meta.internal.semantic.Environment = TermIfQuasiImpl.this.privateEnv;
      override <synthetic> def privateCopy$default$6: scala.meta.internal.semantic.Denotation = TermIfQuasiImpl.this.privateDenot;
      override <synthetic> def privateCopy$default$7: scala.meta.internal.semantic.Typing = TermIfQuasiImpl.this.privateTyping;
      def children: scala.collection.immutable.Seq[scala.meta.Tree] = (immutable.this.Nil: scala.collection.immutable.Seq[scala.meta.Tree]);
      override def productPrefix: String = ("Term.If.Quasi": String);
      override def productArity: Int = 2;
      override def productElement(n: Int): Any = n match {
        case 0 => this.rank
        case 1 => this.tree
        case _ => throw new scala.`package`.IndexOutOfBoundsException(n.toString())
      };
      override def productIterator: Iterator[Any] = scala.runtime.ScalaRunTime.typedProductIterator[Nothing](this);
      protected def writeReplace(): AnyRef = {
        ((): Unit);
        ((): Unit);
        this
      };
      def become[T <: scala.meta.internal.ast.Quasi](implicit ev: scala.meta.internal.ast.AstInfo[T]): T = this match {
        case If.this.Quasi.unapply(<unapply-selector>) <unapply> (0, (tree @ _)) => ev.quasi(0, tree).withTokens(this.tokens).asInstanceOf[T]
        case If.this.Quasi.unapply(<unapply-selector>) <unapply> (1, (nested @ If.this.Quasi.unapply(<unapply-selector>) <unapply> (0, (tree @ _)))) => ev.quasi(1, nested.become[T](ev)).withTokens(this.tokens).asInstanceOf[T]
        case _ => throw new scala.`package`.Exception("complex ellipses are not supported yet")
      }
    };
    <synthetic> private def readResolve(): Object = If.this.Quasi
  };
  @SerialVersionUID(value = 1L) final private[If] class TermIfImpl extends AnyRef with scala.meta.Term.If {
    <paramaccessor> private[this] val privateFlags: meta.internal.flags.Flags = _;
    <stable> <accessor> <paramaccessor> private[meta] def privateFlags: meta.internal.flags.Flags = TermIfImpl.this.privateFlags;
    @transient <paramaccessor> private[this] val privatePrototype: scala.meta.Term.If = _;
    <stable> <accessor> <paramaccessor> private[meta] def privatePrototype: scala.meta.Term.If = TermIfImpl.this.privatePrototype;
    <paramaccessor> private[this] val privateParent: scala.meta.Tree = _;
    <stable> <accessor> <paramaccessor> private[meta] def privateParent: scala.meta.Tree = TermIfImpl.this.privateParent;
    @transient <paramaccessor> private[this] var privateTokens: scala.meta.tokens.Tokens = _;
    <accessor> <paramaccessor> private[meta] def privateTokens: scala.meta.tokens.Tokens = TermIfImpl.this.privateTokens;
    <accessor> <paramaccessor> private[meta] def privateTokens_=(x$1: scala.meta.tokens.Tokens): Unit = TermIfImpl.this.privateTokens = x$1;
    <paramaccessor> private[this] val privateEnv: scala.meta.internal.semantic.Environment = _;
    override <stable> <accessor> <paramaccessor> private[meta] def privateEnv: scala.meta.internal.semantic.Environment = TermIfImpl.this.privateEnv;
    <paramaccessor> private[this] val privateTyping: scala.meta.internal.semantic.Typing = _;
    override <stable> <accessor> <paramaccessor> private[meta] def privateTyping: scala.meta.internal.semantic.Typing = TermIfImpl.this.privateTyping;
    <paramaccessor> private[this] var _cond: scala.meta.Term = _;
    <accessor> <paramaccessor> def _cond: scala.meta.Term = TermIfImpl.this._cond;
    <accessor> <paramaccessor> def _cond_=(x$1: scala.meta.Term): Unit = TermIfImpl.this._cond = x$1;
    <paramaccessor> private[this] var _thenp: scala.meta.Term = _;
    <accessor> <paramaccessor> def _thenp: scala.meta.Term = TermIfImpl.this._thenp;
    <accessor> <paramaccessor> def _thenp_=(x$1: scala.meta.Term): Unit = TermIfImpl.this._thenp = x$1;
    <paramaccessor> private[this] var _elsep: scala.meta.Term = _;
    <accessor> <paramaccessor> def _elsep: scala.meta.Term = TermIfImpl.this._elsep;
    <accessor> <paramaccessor> def _elsep_=(x$1: scala.meta.Term): Unit = TermIfImpl.this._elsep = x$1;
    def <init>(privateFlags: meta.internal.flags.Flags, privatePrototype: scala.meta.Term.If, privateParent: scala.meta.Tree, privateTokens: scala.meta.tokens.Tokens, privateEnv: scala.meta.internal.semantic.Environment, privateTyping: scala.meta.internal.semantic.Typing)(_cond: scala.meta.Term, _thenp: scala.meta.Term, _elsep: scala.meta.Term): scala.meta.Term.If.TermIfImpl = {
      TermIfImpl.super.<init>();
      ()
    };
    def cond: scala.meta.Term = {
      (if (this._cond.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.cond");
          this._cond_=({
            val copyCond$macro$193: scala.meta.Term = {
<artifact> val qual$43: scala.meta.Term = this.privatePrototype.cond;
<artifact> val x$703: scala.meta.Term = this.privatePrototype.cond;
<artifact> val x$704: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$705: meta.internal.flags.Flags = qual$43.privateCopy$default$1;
<artifact> val x$706: scala.meta.tokens.Tokens = qual$43.privateCopy$default$4;
<artifact> val x$707: scala.meta.internal.semantic.Environment = qual$43.privateCopy$default$5;
<artifact> val x$708: scala.meta.internal.semantic.Denotation = qual$43.privateCopy$default$6;
<artifact> val x$709: scala.meta.internal.semantic.Typing = qual$43.privateCopy$default$7;
qual$43.privateCopy(x$705, x$703, x$704, x$706, x$707, x$708, x$709)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyCond$macro$193).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyCond$macro$193
          })
        }
      else
        (): Unit);
      this._cond
    };
    def thenp: scala.meta.Term = {
      (if (this._thenp.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.thenp");
          this._thenp_=({
            val copyThenp$macro$194: scala.meta.Term = {
<artifact> val qual$44: scala.meta.Term = this.privatePrototype.thenp;
<artifact> val x$710: scala.meta.Term = this.privatePrototype.thenp;
<artifact> val x$711: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$712: meta.internal.flags.Flags = qual$44.privateCopy$default$1;
<artifact> val x$713: scala.meta.tokens.Tokens = qual$44.privateCopy$default$4;
<artifact> val x$714: scala.meta.internal.semantic.Environment = qual$44.privateCopy$default$5;
<artifact> val x$715: scala.meta.internal.semantic.Denotation = qual$44.privateCopy$default$6;
<artifact> val x$716: scala.meta.internal.semantic.Typing = qual$44.privateCopy$default$7;
qual$44.privateCopy(x$712, x$710, x$711, x$713, x$714, x$715, x$716)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyThenp$macro$194).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyThenp$macro$194
          })
        }
      else
        (): Unit);
      this._thenp
    };
    def elsep: scala.meta.Term = {
      (if (this._elsep.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.elsep");
          this._elsep_=({
            val copyElsep$macro$195: scala.meta.Term = {
<artifact> val qual$45: scala.meta.Term = this.privatePrototype.elsep;
<artifact> val x$717: scala.meta.Term = this.privatePrototype.elsep;
<artifact> val x$718: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$719: meta.internal.flags.Flags = qual$45.privateCopy$default$1;
<artifact> val x$720: scala.meta.tokens.Tokens = qual$45.privateCopy$default$4;
<artifact> val x$721: scala.meta.internal.semantic.Environment = qual$45.privateCopy$default$5;
<artifact> val x$722: scala.meta.internal.semantic.Denotation = qual$45.privateCopy$default$6;
<artifact> val x$723: scala.meta.internal.semantic.Typing = qual$45.privateCopy$default$7;
qual$45.privateCopy(x$719, x$717, x$718, x$720, x$721, x$722, x$723)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyElsep$macro$195).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyElsep$macro$195
          })
        }
      else
        (): Unit);
      this._elsep
    };
    private[meta] def privateCopy(flags: meta.internal.flags.Flags = TermIfImpl.this.privateFlags, prototype: scala.meta.Tree = this, parent: scala.meta.Tree = TermIfImpl.this.privateParent, tokens: scala.meta.tokens.Tokens = TermIfImpl.this.privateTokens, env: scala.meta.internal.semantic.Environment = TermIfImpl.this.privateEnv, denot: scala.meta.internal.semantic.Denotation = TermIfImpl.this.privateDenot, typing: scala.meta.internal.semantic.Typing = TermIfImpl.this.privateTyping): scala.meta.Tree = new If.this.TermIfImpl(flags, prototype.asInstanceOf[scala.meta.Term.If], parent, tokens, env, typing)((null: scala.meta.Term), (null: scala.meta.Term), (null: scala.meta.Term));
    override <synthetic> def privateCopy$default$1: meta.internal.flags.Flags = TermIfImpl.this.privateFlags;
    override <synthetic> def privateCopy$default$2: scala.meta.Tree = this;
    override <synthetic> def privateCopy$default$3: scala.meta.Tree = TermIfImpl.this.privateParent;
    override <synthetic> def privateCopy$default$4: scala.meta.tokens.Tokens = TermIfImpl.this.privateTokens;
    override <synthetic> def privateCopy$default$5: scala.meta.internal.semantic.Environment = TermIfImpl.this.privateEnv;
    override <synthetic> def privateCopy$default$6: scala.meta.internal.semantic.Denotation = TermIfImpl.this.privateDenot;
    override <synthetic> def privateCopy$default$7: scala.meta.internal.semantic.Typing = TermIfImpl.this.privateTyping;
    def copy(cond: scala.meta.Term = this.cond, thenp: scala.meta.Term = this.thenp, elsep: scala.meta.Term = this.elsep): scala.meta.Term.If = Term.this.If.apply(cond, thenp, elsep).withTokens(new scala.meta.internal.tokens.TransformedTokens(this));
    override <synthetic> def copy$default$1: scala.meta.Term = this.cond;
    override <synthetic> def copy$default$2: scala.meta.Term = this.thenp;
    override <synthetic> def copy$default$3: scala.meta.Term = this.elsep;
    def children: scala.collection.immutable.Seq[scala.meta.Tree] = (scala.collection.immutable.List.apply[scala.meta.Term](this.cond, this.thenp, this.elsep): scala.collection.immutable.Seq[scala.meta.Tree]);
    override def productPrefix: String = ("Term.If": String);
    override def productArity: Int = 3;
    override def productElement(n: Int): Any = n match {
      case 0 => this.cond
      case 1 => this.thenp
      case 2 => this.elsep
      case _ => throw new scala.`package`.IndexOutOfBoundsException(n.toString())
    };
    override def productIterator: Iterator[Any] = scala.runtime.ScalaRunTime.typedProductIterator[Nothing](this);
    protected def writeReplace(): AnyRef = {
      (if (this._cond.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.cond");
          this._cond_=({
            val copyCond$macro$196: scala.meta.Term = {
<artifact> val qual$46: scala.meta.Term = this.privatePrototype.cond;
<artifact> val x$724: scala.meta.Term = this.privatePrototype.cond;
<artifact> val x$725: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$726: meta.internal.flags.Flags = qual$46.privateCopy$default$1;
<artifact> val x$727: scala.meta.tokens.Tokens = qual$46.privateCopy$default$4;
<artifact> val x$728: scala.meta.internal.semantic.Environment = qual$46.privateCopy$default$5;
<artifact> val x$729: scala.meta.internal.semantic.Denotation = qual$46.privateCopy$default$6;
<artifact> val x$730: scala.meta.internal.semantic.Typing = qual$46.privateCopy$default$7;
qual$46.privateCopy(x$726, x$724, x$725, x$727, x$728, x$729, x$730)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyCond$macro$196).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyCond$macro$196
          })
        }
      else
        (): Unit);
      (if (this._thenp.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.thenp");
          this._thenp_=({
            val copyThenp$macro$197: scala.meta.Term = {
<artifact> val qual$47: scala.meta.Term = this.privatePrototype.thenp;
<artifact> val x$731: scala.meta.Term = this.privatePrototype.thenp;
<artifact> val x$732: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$733: meta.internal.flags.Flags = qual$47.privateCopy$default$1;
<artifact> val x$734: scala.meta.tokens.Tokens = qual$47.privateCopy$default$4;
<artifact> val x$735: scala.meta.internal.semantic.Environment = qual$47.privateCopy$default$5;
<artifact> val x$736: scala.meta.internal.semantic.Denotation = qual$47.privateCopy$default$6;
<artifact> val x$737: scala.meta.internal.semantic.Typing = qual$47.privateCopy$default$7;
qual$47.privateCopy(x$733, x$731, x$732, x$734, x$735, x$736, x$737)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyThenp$macro$197).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyThenp$macro$197
          })
        }
      else
        (): Unit);
      (if (this._elsep.==(null))
        {
          scala.Predef.require(this.privatePrototype.!=(null), "internal error when initializing TermIfImpl.elsep");
          this._elsep_=({
            val copyElsep$macro$198: scala.meta.Term = {
<artifact> val qual$48: scala.meta.Term = this.privatePrototype.elsep;
<artifact> val x$738: scala.meta.Term = this.privatePrototype.elsep;
<artifact> val x$739: scala.meta.Term.If.TermIfImpl = this;
<artifact> val x$740: meta.internal.flags.Flags = qual$48.privateCopy$default$1;
<artifact> val x$741: scala.meta.tokens.Tokens = qual$48.privateCopy$default$4;
<artifact> val x$742: scala.meta.internal.semantic.Environment = qual$48.privateCopy$default$5;
<artifact> val x$743: scala.meta.internal.semantic.Denotation = qual$48.privateCopy$default$6;
<artifact> val x$744: scala.meta.internal.semantic.Typing = qual$48.privateCopy$default$7;
qual$48.privateCopy(x$740, x$738, x$739, x$741, x$742, x$743, x$744)
}.asInstanceOf[scala.meta.Term];
            if (meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If](this.privatePrototype).isTypechecked.!=(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked))
              meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term](copyElsep$macro$198).withTypechecked(meta.this.Tree.XtensionTypecheckableTree[scala.meta.Term.If.TermIfImpl](this).isTypechecked)
            else
              copyElsep$macro$198
          })
        }
      else
        (): Unit);
      this
    }
  };
  <synthetic> private def readResolve(): Object = Term.this.If
};
```
